/*
 *------------------------------------------------------------------
 *
 * queue.h
 * Nov 98
 * 304-427A
 * Sorin Lerner (based on original implementation from
 * prof. Cooperstock)
 *
 * Function prototypes for queue.c. The actual queue structure
 * is in threadimpl.h.
 *
 *------------------------------------------------------------------
 */

#ifndef _QUEUE_H_
#define _QUEUE_H_

/*
 * Constants for queues. There are only two, used to tell the queue
 * if it owns the items in the queue.
 */

#define QUEUE_NOT_OWN_DATA 0
#define QUEUE_OWN_DATA 1

/*
 * Queue operations
 */

Queue* QueueCreate(int bOwn);
void QueueDestroy(Queue* q);

int QueueIsEmpty(Queue* q);

void QueueEnqueue(Queue* q, TD* td);   /* Add to tail */ 
TD* QueueDequeue(Queue* q);            /* Remove from head */
void QueueInsert(Queue* q,TD* td);     /* Add according to priority */
TD* QueueDelete(Queue* q,TD* td);      /* Delete any td */

#endif /* _QUEUE_H_ */
