/*
 *------------------------------------------------------------------
 *
 * threadimpl.h
 *
 * Definition of data structures used in the implmentation of the
 * the thread library.
 *
 *------------------------------------------------------------------
 */

#ifndef _THREADIMPL_H_
#define _THREADIMPL_H_

#include "threads.h" /* for ThreadId */

struct _Queue;
typedef struct _Queue Queue; 

typedef struct _Registers {
  unsigned pc;
  unsigned sp;
} Registers;

typedef struct _TD {
  struct _TD *next;       /* points to next TD in this queue */
  ThreadId id;            /* unique identifier assigned to this thread */
  Registers regs;         /* stores PC and SP for later resumption */
  int priority;           /* lower values indicate higher priority */
  struct _Queue *inqueue; /* identifies the queue to which we belong */
  void* orig_stack;
} TD;

struct _Queue {
  TD* tail;
  TD* head;
  int bOwn;   /* if true, queue assumes ownership of inserted elmts */
};


#endif  /* #ifndef _THREADIMPL_H_ */
